/*



*/

import java.time.Instant;
import java.time.Duration;
import java.util.Date;
import java.text.SimpleDateFormat;
import java.io.IOException;
import java.io.FileReader;
import java.io.BufferedReader;

public class CountBytes_v3_File
{
   private static final int BUFFERSIZE = 16 * 8192; // changing this doesn't seem to matter

   public static void main(String[] args) throws IOException
   {
      BufferedReader br = new BufferedReader(new FileReader("data"), BUFFERSIZE);

      String oneLine = null;

      final SimpleDateFormat ft = new SimpleDateFormat("hh:mm:ss");
      System.out.println(ft.format(new Date()) + " Count bytes in File ver 3");
      Instant start = Instant.now();
      long byteCounter = 0;

      while ( (oneLine = br.readLine()) != null )
      {
         byteCounter += 1 + oneLine.length();
      }

      Instant stop = Instant.now();
      long time = Duration.between(start, stop).toMillis();
      System.out.printf("%s %,d bytes read from file.\n", ft.format(new Date()), byteCounter);
      System.out.printf("elapsed time: %,dms\n", time);
      br.close();
   }
}
