/*



*/

import java.time.Instant;
import java.time.Duration;
import java.util.Date;
import java.text.SimpleDateFormat;
import java.io.IOException;
import java.io.InputStream;
import java.io.FileInputStream;
import java.io.BufferedInputStream;

public class CountLines_v2_File
{
   private static final int BUFFERSIZE = 16 * 8192;

   public static void main(String[] args) throws IOException
   {
    //final InputStream is = new FileInputStream("data"); // no buffering
      final InputStream is = new BufferedInputStream(new FileInputStream("data")); // default buffering
    //final InputStream is = new BufferedInputStream(new FileInputStream("data"), BUFFERSIZE);

      int c;

      final SimpleDateFormat ft = new SimpleDateFormat("hh:mm:ss");
      System.out.println(ft.format(new Date()) + " Count lines in File ver 2");
      Instant start = Instant.now();
      long byteCounter = 0;
      long lineCounter = 1;

      while ( (c = is.read()) != -1 ) // read one byte at a time
      {
         ++byteCounter;
         if ( '\n' == c )
         {
            ++lineCounter;
         }
      }

      Instant stop = Instant.now();
      long time = Duration.between(start, stop).toMillis();
      System.out.printf("%s %,d bytes read from file.\n", ft.format(new Date()), byteCounter);
      System.out.printf("%s %,d lines read from file.\n", ft.format(new Date()), lineCounter);
      System.out.printf("elapsed time: %,dms\n", time);
      is.close();
   }
}
