/*



*/

import java.time.Instant;
import java.time.Duration;
import java.util.Date;
import java.text.SimpleDateFormat;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.BufferedReader;

public class CountLines_v3_stdin
{
   private static final int BUFFERSIZE = 16 * 8192; // changing this doesn't seem to matter

   public static void main(String[] args) throws IOException
   {
      BufferedReader br = new BufferedReader(new InputStreamReader(System.in), BUFFERSIZE);

      String oneLine = null;

      final SimpleDateFormat ft = new SimpleDateFormat("hh:mm:ss");
      System.out.println(ft.format(new Date()) + " Count lines in stdin ver 3");
      Instant start = Instant.now();
      long byteCounter = 0;
      long lineCounter = 1;

      while ( (oneLine = br.readLine()) != null )
      {
         ++lineCounter;
         byteCounter += 1 + oneLine.length();
      }

      Instant stop = Instant.now();
      long time = Duration.between(start, stop).toMillis();
      System.out.printf("%s %,d bytes read from stdin.\n", ft.format(new Date()), byteCounter);
      System.out.printf("%s %,d lines read from stdin.\n", ft.format(new Date()), lineCounter);
      System.out.printf("elapsed time: %,dms\n", time);
      br.close();
   }
}
