import java.io.*;
import java.nio.file.*;
import java.util.concurrent.*;
import java.util.Stack;
public class Search3
{
   public static void main(String[] args)
   {
      byte[] compare = args[0].getBytes();
      ExecutorService pool;
      int poolSize = 2;
      int count = 0;
      try
      {
         pool = Executors.newFixedThreadPool(poolSize);
         Stack<MatchService> work = new Stack<MatchService>();
         int lineNumber = 0;
         int bufferSize = 128 * 1024;
         byte[] buffer = new byte[bufferSize];
         while(System.in.read(buffer, 0, bufferSize) != -1)//NOTE, buffer need not be full!
         {
            MatchService temp = new MatchService(buffer, compare);
            Future job = pool.submit(temp);
            work.add(temp);
         }



         //close up
         pool.shutdown();
         pool.awaitTermination(120, TimeUnit.SECONDS);
         while(!work.empty())
         {
            count += work.pop().getMatches();
         }
         System.out.println("count: " + count);

      }
      catch(Exception e)  {e.printStackTrace(); System.out.println("count: "  + count);}
   }
}







class MatchService implements Runnable
{
   byte[] buffer;
   byte[] comp;
   int counts;
   volatile boolean complete;

   public MatchService(byte[] data, byte[] target)
   {
      buffer = new byte[data.length];
      comp   = new byte[target.length];
      for(int index = 0; index < buffer.length; index++)  {buffer[index] = data[index];}
      for(int index = 0; index < target.length; index++)  {comp[index]   = target[index];}
      counts = 0;
      complete = false;
   }


   public void run()
   {
      for(int index = 0; index < (buffer.length - (comp.length)); index++)
      {
         boolean contains = true;
         for(int i = 0; i < comp.length; i++)
         {if(buffer[index + i] != comp[i])  {contains = false; break;}}
         if(contains)  {counts++;}
      }
      complete = true;
   }


   public boolean isDone()  {return(complete);}
   public void waitTillDone()  {try{while(!complete)  {Thread.sleep(1);}}  catch(Exception e)  {e.printStackTrace(); System.exit(-1);}}
   public int getMatches()  {waitTillDone();  return(counts);}

}
