import java.io.*;
import java.nio.file.*;
import java.util.concurrent.*;
import java.util.Stack;
public class Search3_v2
{
   public static void main(String[] args)
   {
      byte[] compare = "aardvark".getBytes(); //args[0].getBytes();
      ExecutorService pool;
      int poolSize = 2;
      int count = 0;
      try
      {
         pool = Executors.newFixedThreadPool(poolSize);
         Stack<MatchService> work = new Stack<MatchService>();
         int lineNumber = 0;
         int bufferSize = 128 * 1024;
         byte[] buffer = new byte[bufferSize];
         while(System.in.read(buffer, 0, bufferSize) != -1)//NOTE, buffer need not be full!
         {
            MatchService temp = new MatchService(buffer, compare);
            pool.execute(temp);
            work.add(temp);
            buffer = new byte[bufferSize];
         }


         //close up
         pool.shutdown();
         pool.awaitTermination(120, TimeUnit.SECONDS);
         while(!work.empty())
         {
            count += work.pop().getMatches();
         }
         System.out.println("count: " + count);

      }
      catch(Exception e)  {e.printStackTrace(); System.out.println("count: "  + count);}
   }
}







class MatchService implements Runnable
{
   byte[] buffer;
   byte[] comp;
   int counts;


   public MatchService(byte[] data, byte[] target)
   {
      buffer = data;
      comp   = target;
      counts = 0;
   }





   public void run()
   {
      for(int index = 0; index < (buffer.length - (comp.length)); index++)
      {
         boolean contains = true;
         for(int i = 0; i < comp.length; i++)
         {if(buffer[index + i] != comp[i])  {contains = false; break;}}
         if(contains)  {counts++;}
      }
   }

   public int getMatches(){return(counts);}
}
